<template>
    <div class="History p-8">
      <div class="shadow-lg rounded-md overflow-hidden">
        <h2 class="font-medium text-xl text-gray-600 bg-white p-6">List of actions commited</h2>
        <div class="p-6 bg-gray-100">
          <div class="shadow-lg rounded-md bg-white">
            <template v-if="commits.length === 0">
              <div class="p-6 text-gray-500 text-center">No actions commited</div>
            </template>
            <HistoryItem
              v-for="(commit, index) in commits"
              @revert="revert"
              :key="commit.uniqueId" :index="index"
              :commitDetails="commit" />
          </div>
        </div>
      </div>
    </div>
  </template>
  
  <script>
  import { mapState, mapActions } from 'pinia';
  import { useHistoryStore } from '@/stores/HistoryStore';
  import HistoryItem from './HistoryItem.vue';

  export default {
    name: 'History',
    components: {
      HistoryItem,
    },
    computed: {
      ...mapState(useHistoryStore, ['commits']),
    },
    methods: {
      ...mapActions(useHistoryStore, ['revertAction']),
      /**
       * @param {number} index - The index of the commit to revert
       * @returns {void}
      */
      revert(index) {
        this.revertAction(this.commits.length - index);
        this.$emit('revert');
      }
    }
  }
  </script>
  